header {
/*
 * ============================================================================
 * Licensed Materials - Property of IBM
 * WebSphere sMash
 *
 * (C) Copyright IBM Corp. 2007,2008  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 * ============================================================================
 */
 
package zero.core.events.antlr;
}


/* #################################################################### */
/* #                              Lexer                                 */
/* #################################################################### */
{
import antlr.TokenStreamSelector;
	import java.util.logging.Level;
	import java.util.logging.Logger;

	import zero.core.logging.LogHelper;

}
class ValueLexer extends Lexer;

options {
	k=1;
	charVocabulary = '\0'..'\ufffe';  // uffff is EOF
	defaultErrorHandler=false;
	testLiterals=false;
}

{
	private static final String CLASS_NAME = ValueLexer.class.getName();
	private static final Logger _logger = Logger.getLogger(CLASS_NAME, "zero.kernel.messages");
	
TokenStreamSelector _selector = null;

public void setSelector(TokenStreamSelector selector) {
	_selector = selector;
}
}

Value
	: (NValue)+
		{ _selector.pop(); }
	;

// Change the * to a + if we require at least 1 element between ( )
protected NValue
	: '(' (NValue)* ')'
	| {LA(2) != '&'}? '&'
	| {LA(2) != '|'}? '|'
	| (~('(' | ')' | '&' | '|'))+
	;
